/*
 * Copyright (c) 2010 Dylan Reinhold.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 3. Neither the name of The DragonFly Project nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific, prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/sysctl.h>
#include "devserno.h"

int
dev_list() {
	char disks[100];
	int rc,i=0;
	int size = 99;
	char *dev;
	dev_t tmp_dev_rdev;
	rc = sysctlbyname("kern.disks", &disks, &size, NULL, 0);
	/* printf("RC %d, Val %s\n",rc,disks); */
	if(rc != 0)
		return rc;
	dev = strtok(disks, " ");
	while(dev != NULL) {
		tmp_dev_rdev = dev_stat("/dev/",dev);
		/* walk current devserno stuct for the match */
		for(i=0;i<DevCount;++i) {
			if(DevSerno[i].dev_rdev == tmp_dev_rdev) {
				asprintf(&DevSerno[i].dev_name,dev);
				i=DevCount;
			}
		}
		dev = strtok(NULL," ");
		if( i >= MAX_DEVICES ) {
			fprintf(stderr,"error : Too many devies in sysctl "
				"kern.disks, try and increase MAX_DEVICE.\n");
			break;
		}

	}
  return 0;
}
